	 AREA    FPALibPROC,CODE,READONLY

;///////////////////////////////////////////////////////////////////////////////////
;Integer to float, float to integer, double to integer, integer to double,
;float to double and double to float.
Uint64ToFloat       PROC
                    EXPORT     	Uint64ToFloat
					CMP         R1,#0x00
					ITTEE       EQ
					CLZEQ       R3,R0
					RSBEQ       R3,#0x20
					CLZNE       R3,R1
					RSBNE       R3,#0x40
					SUBS        R2,R3,#0x38
					BHI         UToFMoreThan56Bits
					SUBS        R2,R3,#0x18
					BHI         UToFMoreThan24Bits
UToFLessThan24Bits  RSB         R2,R3,#0x18
                    CBZ         R0,UTFZeroOprand
					LSLS        R0,R2
					ADDS        R3,#0x7E
					BFI         R0,R3,#0x17,#0x08
UTFZeroOprand		BX          R14
UToFMoreThan56Bits  LSRS        R0,R1,R2
                    ADD         R3,#0x7E
					BFI         R0,R3,#0x17,#0x08
					ADC         R0,#0x00
					BX          R14
UToFMoreThan24Bits	LSRS        R0,R2
					RSB         R2,#0x20
					LSL         R1,R2
					ORR         R0,R1
					ADD         R3,#0x7E
					BFI         R0,R3,#0x17,#0x08
					ADC         R0,#0x00
					BX          R14
					ENDP
FloatToUint64       PROC
	                EXPORT      FloatToUint64
					UBFX        R1,R0,#0x00,#0x17
					ORR         R1,#0x800000
					UBFX        R0,R0,#0x17,#0x08
					SUBS        R2,R0,#0x96
					BHI         FToUMoreThan24Bits
FToULessThan24Bits	RSB         R0,#0x96
					LSRS        R0,R1,R0
					EORS        R1,R1
                    BX          R14
FToUMoreThan24Bits	LSL         R0,R1,R2
					SUBS        R3,R2,#0x20
					ITEE        HS
					LSLHS       R1,R3
                    RSBLO       R3,R2,#0x20
					LSRLO       R1,R3
					BX          R14					
					ENDP
Int64ToFloat        PROC
	                EXPORT      Int64ToFloat
					PUSH        {R4,R14}
					ASR         R4,R1,#0x20
					EORS        R0,R4
					EORS        R1,R4
					ADDS        R0,R4,LSR#0x1F
					ADC         R1,#0x00
					BL          Uint64ToFloat
					ORR         R0,R4,LSL#0x1F
					POP         {R4,R15}
					ENDP
FloatToInt64        PROC
	                EXPORT      FloatToInt64
					PUSH        {R4,R14}
					ASR         R4,R0,#0x20
					BL          FloatToUint64
					EORS        R0,R4
					EORS        R1,R4
					ADDS        R0,R4,LSR#0x1F
					ADC         R1,#0x00
					POP         {R4,R15}
	                ENDP
Uint32ToFloat       PROC
	                EXPORT      Uint32ToFloat
				    CBZ         R0,U32TFZeroOperand
	                CLZ         R1,R0
					RSBS        R2,R1,#0x08
					BHI         U32TFMoreThan24Bits
U32TFLessThan24Bits SUB         R2,R1,#0x08
					LSLS        R0,R2
					RSB         R2,R1,#0x9E
					BFI         R0,R2,#0x17,#0x09
					BX          R14
U32TFMoreThan24Bits	LSRS        R0,R2
					RSB         R2,R1,#0x9E
					BFI         R0,R2,#0x17,#0x09
					ADC         R0,#0x00
U32TFZeroOperand	BX          R14
	                ENDP
FloatToUint32       PROC
	                EXPORT      FloatToUint32
                    UBFX        R1,R0,#0x00,#0x17
					ORR         R1,#0x800000
					UBFX        R0,R0,#0x17,#0x08
					SUBS        R2,R0,#0x96
					BHS         FTU32MoreThan24Bits
FTU32LessThan24Bits RSB         R0,#0x96
                    LSRS        R0,R1,R0
                    BX          R14
FTU32MoreThan24Bits LSL         R0,R1,R2
                    BX          R14
	                ENDP
Int32ToFloat        PROC
	                EXPORT      Int32ToFloat
					PUSH        {R14}
					ASR         R3,R0,#0x20
					EORS        R0,R3
					ADD         R0,R3,LSR#0x1F
					BL          Uint32ToFloat
					ORR         R0,R3,LSL#0x1F
					POP         {R15}
					ENDP
FloatToInt32        PROC
	                EXPORT      FloatToInt32
					PUSH        {R14}
					ASR         R3,R0,#0x20
					BL          FloatToUint32
					EORS        R0,R3
					ADDS        R0,R3,LSR#0x1F
					POP         {R14}
					ENDP
Uint64ToDouble      PROC
	                EXPORT      Uint64ToDouble
					CMP         R1,#0x00
					ITTE        EQ
					CLZEQ       R3,R0
					ADDEQ       R3,#0x20
					CLZNE       R3,R1
					SUBS        R2,R3,#0x2B
					BHI         UTDLessThan21Bits
					SUBS        R2,R3,#0x0B
					BHS         UTDLessThan53Bits
UTDMoreThan53Bits   RSB         R2,R3,#0x0B
                    LSRS        R0,R2
					RSB         R2,#0x20
				    LSL         R2,R1,R2
					ADCS        R0,R2
					RSB         R2,R3,#0x0B
					LSR         R1,R2
					MOV         R2,#0x043E
					SUB         R2,R3
					BFI         R1,R2,#0x14,#0x0C
					ADC         R1,#0x00
					BX          R14
UTDLessThan21Bits   LSL         R1,R0,R2
                    CBZ         R1,UTDZeroOperand
                    RSB         R2,#0x15
					ADD         R2,#0x03FE
					BFI         R1,R2,#0x14,#0x0C
                	EORS        R0,R0
UTDZeroOperand		BX          R14
UTDLessThan53Bits   LSLS        R1,R2
                    RSB         R2,#0x20
					LSRS        R2,R0,R2
					ORRS        R1,R2
					SUB         R2,R3,#0x0B
					LSLS        R0,R2
					MOV         R2,#0x43E
					SUBS        R2,R3
					BFI         R1,R2,#0x14,#0x0C
                    BX          R14
	                ENDP
DoubleToUint64      PROC
	                EXPORT      DoubleToUint64
                    UBFX        R2,R1,#0x14,#0x0B
					ORR         R1,#0x100000
					BFC         R1,#0x15,#0x0B
					MOV         R3,#0x0433
					SUBS        R3,R2,R3
					BHS         DTUMoreThan53Bits
					MOV         R3,#0x413
					SUBS        R3,R2
					BHS         DTULessThan21Bits
DTUMoreThan21Bits   MOV         R3,#0x433
                    SUBS        R3,R2
                    LSLS        R1,R3
                    RSB         R2,R3,#0x20
					LSRS        R2,R0,R2
					ORRS        R1,R2
					LSLS        R0,R3
					BX          R14
DTULessThan21Bits   LSL         R1,R0,R3
                    EORS        R0,R0
					BX          R14
DTUMoreThan53Bits   LSRS        R0,R3
                    RSB         R2,R3,#0x20
					LSLS        R2,R1,R2
					ORRS        R0,R2
					LSRS        R1,R3
					BX          R14
					ENDP
Int64ToDouble       PROC
	                EXPORT      Int64ToDouble
					PUSH        {R4,R14}
					ASR         R4,R1,#0x20
					EORS        R0,R4
					EORS        R1,R4
					ADDS        R0,R4,LSR#0x1F
					ADC         R1,#0x00
					BL          Uint64ToDouble
					ORR         R1,R4,LSL#0x1F
					POP         {R4,R15}
					ENDP
DoubleToInt64       PROC
	                EXPORT      DoubleToInt64
					PUSH        {R4,R14}
					ASR         R4,R1,#0x20
					BL          DoubleToUint64
					EORS        R0,R4
					EORS        R1,R4
					ADDS        R0,R4,LSR#0x1F
					ADC         R1,#0x00
					POP         {R4,R15}
					ENDP
FloatToDouble       PROC
	                EXPORT      FloatToDouble
					AND         R1,R0,#0x80000000
					UBFX        R2,R0,#0x00,#0x17
					UBFX        R0,R0,#0x17,#0x08
					CBZ         R0,FTDZeroResult
					ADD         R0,#0x0380
					BFI         R1,R0,#0x14,#0x0B
					ORR         R1,R2,LSR#0x03
					LSL         R0,R2,#0x1D
					BX          R14
FTDZeroResult       EORS        R0,R0
                    EORS        R1,R1
					BX          R14
					ENDP
DoubleToFloat       PROC
	                EXPORT      DoubleToFloat
					AND         R2,R1,#0x80000000
					ORRS        R0,R2,R0,LSR#0x1D
					BFI         R0,R1,#0x03,#0x14
					UBFX        R1,R1,#0x14,#0x0B
					CBZ         R1,DTFZeroResult
					SUB         R1,#0x0380
					ADC         R0,R1,LSL#0x17
					BX          R14
DTFZeroResult       EORS        R0,R0
                    BX          R14
					ENDP
;///////////////////////////////////////////////////////////////////////////////////
;Four arithmetic operations of single floating point with single floating point results.
FloatSubtract       PROC
	                EXPORT      FloatSubtract	
					EOR         R1,#0x80000000
					B           FloatAdd
					ENDP
FloatAdd            PROC
	                EXPORT      FloatAdd
					BIC         R2,R0,#0x80000000
					BIC         R3,R1,#0x80000000
					CMP         R2,R3
                    ITTT        LO					
					EORLO       R0,R1
                    EORLO       R1,R0
                    EORLO       R0,R1
                    UBFX        R2,R0,#0x17,#0x08
					UBFX        R3,R1,#0x17,#0x08
					CBZ         R3,FAZeroOperand
				    SUBS        R2,R3
					EORS        R3,R1,R0
					BPL         FAPPOrNN
FAPAndN 		    UBFX        R3,R0,#0x00,#0x17
					ORRS        R3,#0x800000
					UBFX        R1,R1,#0x00,#0x17
					ORRS        R1,#0x800000
                    LSRS        R1,R2
					ADC         R1,#0x00
				    SUBS        R3,R1
				    BEQ         FAZeroResult
        		    CLZ         R2,R3
				    SUB         R2,#0x08
				    LSLS        R3,R2
        		    SUB         R0,R2,LSL#0x17
				    BFI         R0,R3,#0x00,#0x17
FAZeroOperand       BX          R14
FAZeroResult        EORS        R0,R0
					BX          R14 
FAPPOrNN            MOV         R3,#0x80000000
                    ORR         R1,R3,R1,LSL#0x08
                    ORR         R3,R0,LSL#0x08
                    LSRS        R1,R2
                    ADDS        R3,R1
					EORS        R2,R2
					ADCS        R1,R2,R2
					ADD         R0,R1,LSL#0x17
					ADDS        R1,#0x08
					LSRS        R3,R1
					BFI         R0,R3,#0x00,#0x17
					ADCS        R0,R2
                    BX          R14
					ENDP
FloatDivide         PROC
	                EXPORT      FloatDivide
					UBFX        R2,R0,#0x17,#0x08
					UBFX        R3,R1,#0x17,#0x08
					CBZ         R2,FDZeroOperand
					SUBS        R2,R3
					ADDS        R2,#0x7E
					LSL         R3,R0,#0x08
					ORR         R3,#0x80000000
					EORS        R0,R1
                    UBFX        R1,R1,#0x00,#0x17
					ORR         R1,#0x800000
					BFI         R0,R2,#0x17,#0x08       
					UDIV        R2,R3,R1
					MLS         R3,R1,R2,R3
					TST         R2,#0x0100
					LSL         R3,#0x08
					BFI         R0,R2,#0x0F,#0x08
					UDIV        R2,R3,R1
					MLS         R3,R2,R1,R3
					BFI         R0,R2,#0x07,#0x08
					LSL         R3,#0x08
					UDIV        R2,R3,R1
					BNE         FD25BitsResult
FD24BitsResult  	BFI         R0,R0,#0x01,#0x16
                    BFI         R0,R2,#0x00,#0x08
                    MLS         R3,R2,R1,R3
					RSBS        R1,R3,LSL#0x01
					ADC         R0,#0x00
					BX          R14
FD25BitsResult  	LSRS        R2,#0x01
					BFI         R0,R2,#0x00,#0x07
					ADC         R0,#0x800000
                    BX          R14
FDZeroOperand       EORS        R0,R0
                    BX          R14
					ENDP
FloatMultiply       PROC
	                EXPORT      FloatMultiply
                    AND         R2,R0,#0x7F800000
					AND         R3,R1,#0x7F800000
					CBZ         R2,FMZeroOperand
					CBZ         R3,FMZeroOperand
					ADD         R3,R2
					SUB         R3,#0x3F800000
					EORS        R2,R0,R1
					BFI         R2,R3,#0x00,#0x1F
					MOV         R3,#0x80000000
					ORR         R1,R3,R1,LSL#0x08
					ORR         R3,R0,LSL#0x08
					UMULL       R1,R3,R1,R3
					LSR         R1,R3,#0x1F
                    ADD         R2,R1,LSL#0x17
					ADDS        R1,#0x07
                    LSRS        R3,R1
					BIC         R0,R3,#0x800000
					ADCS        R0,R2
                    BX          R14
FMZeroOperand       EORS        R0,R0
					BX          R14
	                ENDP
;///////////////////////////////////////////////////////////////////////////////////
;Four arithmetic operations of single floating point with double floating point results.
FloatSubToDouble    PROC
	                EXPORT      FloatSubToDouble	
					EOR         R1,#0x80000000
					B           FloatAddToDouble
					ENDP
FloatAddToDouble    PROC
					EXPORT      FloatAddToDouble
					BIC         R2,R0,#0x80000000
					BIC         R3,R1,#0x80000000
					CMP         R2,R3
                    ITTT        LO					
					EORLO       R0,R1
                    EORLO       R1,R0
                    EORLO       R0,R1
					UBFX        R2,R0,#0x17,#0x08
					UBFX        R3,R1,#0x17,#0x08
					CBZ         R3,FATDZeroOperand
					SUBS        R2,R3
					EORS        R3,R1,R0
					PUSH        {R14}
					BPL         FATDPPOrNN
FATDPAndN           UBFX        R3,R1,#0x03,#0x14
					LSL         R1,#0x1D
					ORR         R3,#0x100000
                    SUBS        R14,R2,#0x20
                    BLO         FATDShift0LT32Bits
FATDShift0HT32Bits	ANDS        R2,#0x00
                    LSRS        R1,R3,R14
					MOVS        R3,R2
					B           FATDShift0End
FATDZeroOperand     B           FloatToDouble
FATDShift0LT32Bits  RSB         R14,R2,#0x20
                    LSRS        R1,R2
					LSR         R2,R3,R2
					LSL         R3,R14
FATDShift0End	    ADCS        R1,R3
                    UBFX        R14,R0,#0x17,#0x08
					ADD         R14,#0x0380
					LSR         R3,R0,#0x1F
					ORR         R14,R3,LSL#0x0B
                    UBFX        R3,R0,#0x03,#0x14
					ORR         R3,#0x100000
                    RSBS        R0,R1,R0,LSL#0x1D
                    SBCS        R1,R3,R2
					ITTEE       EQ
					CLZEQ       R3,R0
					ADDEQ       R3,#0x15
					CLZNE       R3,R1
					SUBNE       R3,#0x0B
					SUB         R14,R3
					RSBS        R2,R3,#0x20
                    BLO         FATDShift1HT32Bits
FATDShift1LT32Bits  LSRS        R2,R0,R2
					LSLS        R1,R3
					ORRS        R1,R2
					LSLS        R0,R3
            	    BFI         R1,R14,#0x14,#0x0C
					POP         {R4,R15}
FATDShift1HT32Bits	SUB         R2,R3,#0x20
                    LSL         R1,R0,R2
					EORS        R0,R0
					CBZ         R1,FATDZeroResult
					BFI         R1,R14,#0x14,#0x0C
					POP         {R14}
FATDZeroResult		EORS        R1,R1
                    POP         {R14}
FATDPPOrNN          LSL         R1,#0x08
					ORR         R1,#0x80000000
					UBFX        R14,R0,#0x17,#0x08
					LSR         R3,R0,#0x1F
					ORR         R14,R3,LSL#0x0B
					ORR         R3,R0,#0x800000
                    SUBS        R0,R2,#0x20
                    BLO         FATDShift2LT32Bits
FATDShift2HT32Bits	LSRS        R0,R1,R0
					EORS        R1,R1
					B           FATDShift2End
FATDShift2LT32Bits  RSB         R0,R2,#0x20
                    LSLS        R0,R1,R0
					LSRS        R1,R2
FATDShift2End	    ADDS        R1,R3,LSL#0x08
                    ADC         R14,#0x380
					EORS        R2,R2
					ADC         R3,R2,#0x0B
					LSRS        R0,R3
					RSB         R2,R3,#0x20
                    LSL         R2,R1,R2
					LSR         R1,R3
					BFI         R1,R14,#0x14,#0x0C
					ADCS        R0,R2
					ADC         R1,#0x00
					POP         {R15}
	                ENDP
FloatMulToDouble    PROC
	                EXPORT      FloatMulToDouble
					UBFX        R2,R0,#0x17,#0x08
					UBFX        R3,R1,#0x17,#0x08
					CBZ         R2,FMTDZeroOperand
					CBZ         R3,FMTDZeroOperand
					ADD         R2,R3
					ADD         R2,#0x0301
					EOR         R3,R1,R0
					BFI         R3,R2,#0x14,#0x0B
					MOV         R2,#0x80000000
					ORR         R1,R2,R1,LSL#0x08
					ORR         R0,R2,R0,LSL#0x08
					UMULL       R0,R1,R0,R1
					LSR         R2,R1,#0x1F
                    ADD         R3,R2,LSL#0x14
					ADDS        R2,#0x0A
					LSRS        R0,R2
					RSB         R2,#0x20
					LSL         R2,R1,R2
					ADCS        R0,R2
					LSR         R2,R1,#0x1F
					ADD         R2,#0x0A
					LSR         R1,R2
					BFI         R3,R1,#0x00,#0x14
					ADC         R1,R3,R2,LSR#0x1F
                    BX          R14
FMTDZeroOperand     EORS        R0,R0
                    EORS        R1,R1
					BX          R14
					ENDP
FloatDivideToDouble PROC
	                EXPORT      FloatDivideToDouble
	                PUSH        {R14}
					LSLS        R2,R0,#0x01
					UBFX        R3,R1,#0x17,#0x08
					BEQ         FDTDZeroOperand
					RSB         R2,R3,R2,LSR#0x17
					ADD         R2,#0x03FE
					UBFX        R3,R1,#0x00,#0x17
					ORR         R3,#0x800000
					EORS        R1,R0
                    LSL         R4,R0,#0x08
					ORR         R4,#0x80000000
                    BFI         R1,R2,#0x14,#0x0B					
					UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					ANDS        R0,R2,#0x0100
                    BFI         R1,R2,#0x0C,#0x08
					ADD         R1,R0,LSL#0x0C
					LSL         R4,#0x08
                    UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					BFI         R1,R2,#0x04,#0x08
					LSL         R4,#0x08
                    UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					BFI         R0,R2,#0x1C,#0x04
					LSR         R2,#0x04
					BFI         R1,R2,#0x00,#0x04
					LSL         R4,#0x08
                    UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					BFI         R0,R2,#0x14,#0x08
					LSL         R4,#0x08
                    UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					BFI         R0,R2,#0x0C,#0x08
					LSL         R4,#0x08
                    UDIV        R2,R4,R3
                    MLS         R4,R2,R3,R4
					BFI         R0,R2,#0x04,#0x08
                    LSL         R4,#0x08
                    UDIV        R2,R4,R3
					BHS         FDTD53BitResult
FDTD52BitResult	    BFI         R1,R1,#0x01,#0x13
                    BIC         R1,#0x01
					LSLS        R0,#0x01
					ADC         R1,#0x00
					LSRS        R2,#0x03 
					ADCS        R0,R2
					ADC         R1,#0x00
                    POP         {R15}
FDTD53BitResult     LSRS        R2,#0x04     
					ADCS        R0,R2
					ADC         R1,#0x00
                    POP         {R15}
FDTDZeroOperand     EORS        R0,R0
                    EORS        R1,R1
					POP         {R4,R15}
	                ENDP
;///////////////////////////////////////////////////////////////////////////////////
;Four arithmetic operations of double floating point with single floating point results.
Uint64MulToUint128  PROC
	                EXPORT      Uint64MulToUint128
	                PUSH        {R4-R5,R14}
					UMULL       R4,R5,R0,R3
					UMULL       R0,R14,R0,R2
					ADDS        R4,R14
					ADC         R5,#0x00
					UMULL       R2,R14,R1,R2
					UMULL       R1,R3,R1,R3
					ADDS        R4,R2
					ADCS        R2,R5,R14
					ADC         R3,#0x00
					ADDS        R2,R1
					ADC         R3,#0x00
					MOVS        R1,R4
					POP         {R4-R5,R15}
					ENDP
UDIV64              PROC
	                EXPORT      UDIV64
					PUSH        {R4-R7,R14}
                    SUBS        R4,R0,R2
					SBC         R5,R1,R3
					BLO         UDIV64ZeroResult
					EORS        R4,R4
					EORS        R5,R5
					EORS        R6,R6
					MOV         R14,#0x40
UDIV64Loop			LSLS        R0,#0x01
                    UBFX        R7,R1,#0x1F,#0x01
					ADC         R1,R6,R1,LSL#0x01
					ORRS        R4,R7,R4,LSL#0x01
					ADC         R5,R6,R5,LSL#0x01
UDIV64SubChk        CMP         R4,R2
					SBCS        R7,R5,R3
                    BLO         UDIV64SubSkip
                    ADDS        R0,#0x01
                    SUBS        R4,R2
					SBCS        R5,R3
UDIV64SubSkip       SUBS        R14,#0x01
					BHI         UDIV64Loop
					POP         {R4-R7,R15}
UDIV64ZeroResult    EORS        R1,R1
                    EORS        R0,R1
                    POP         {R4-R7,R15}
	                ENDP
DoubleAddToFloat    PROC
					EXPORT      DoubleAddToFloat
					PUSH        {R4,R14}
					BIC         R4,R1,#0x80000000
					BIC         R14,R3,#0x80000000
					CMP         R0,R2
					SBCS        R4,R14
                    ITTT        LO					
					EORLO       R0,R2
                    EORLO       R2,R0
                    EORLO       R0,R2
					ITTT        LO					
					EORLO       R1,R3
                    EORLO       R3,R1
                    EORLO       R1,R3
					UBFX        R14,R1,#0x17,#0x08
					UBFX        R4,R3,#0x17,#0x08
					CBZ         R4,DATFZeroOperand
					SUB         R4,R14,R4
					EORS        R14,R1,R3
					BPL         DATFPPOrNN
DATFPAndN           ORR         R3,#0x100000
                    LSL         R3,#0x03
					ORR         R3,R2,LSR#0x1D
					LSL         R2,#0x03
					BIC         R3,#0xFF000000
                    SUBS        R14,R4,#0x20
                    BLO         DATFShift0LT32Bits
DATFShift0HT32Bits	ANDS        R4,#0x00
                    LSRS        R2,R3,R14
					MOVS        R3,R4
					B           DATFShift0End
DATFZeroOperand     POP         {R4,R14}
                    B           DoubleToFloat
DATFShift0LT32Bits  RSB         R14,R4,#0x20
                    LSRS        R2,R4
					LSR         R4,R3,R4
					LSL         R3,R14
DATFShift0End	    ADCS        R2,R3
                    ORR         R3,R1,#0x100000
					LSL         R3,#0x03
					ORR         R3,R0,LSR#0x1D
					BIC         R3,#0xFF000000
                    RSBS        R2,R0,LSL#0x03
					SBCS        R0,R3,R4
					ITTEE       EQ
					CLZEQ       R4,R2
					ADDEQ       R4,#0x18
					CLZNE       R4,R0
					SUBNE       R4,#0x08
					SUB         R1,R4,LSL#0x14
					UBFX        R14,R1,#0x14,#0x0B
                    SUB         R14,#0x0380
					LSR         R1,#0x1F
					ORR         R14,R1,LSL#0x08
					RSBS        R3,R4,#0x20
                    BLS         DATFShift1HT32Bits
DATFShift1LT32Bits  LSRS        R3,R2,R3
					LSLS        R0,R4
					ORRS        R0,R3
					LSLS        R2,R4
					BFI         R0,R14,#0x17,#0x09
					ADD         R0,R2,LSR#0x1F
					POP         {R4,R15}
DATFShift1HT32Bits	SUB         R3,R4,#0x20
                    LSL         R0,R2,R3
					EORS        R2,R2
					CBZ         R0,DATFZeroResult
					BFI         R0,R3,#0x17,#0x09
					POP         {R4,R15}
DATFZeroResult		EORS        R0,R0
                    POP         {R4,R15}
DATFPPOrNN          LSL         R3,#0x0B
                    ORR         R3,#0x80000000
					ORR         R3,R2,LSR#0x15
					LSL         R2,#0x0B
                    SUBS        R14,R4,#0x20
                    BLO         DATFShift2LT32Bits
DATFShift2HT32Bits	LSR         R2,R3,R14
					EORS        R3,R3
					B           DATFShift2End
DATFShift2LT32Bits  RSB         R14,R4,#0x20
                    LSRS        R2,R4
					LSL         R14,R3,R14
					LSRS        R3,R4
					ORR         R2,R14
DATFShift2End	    LSL         R4,R1,#0x0B
                    ORR         R4,#0x80000000
					ORR         R4,R0,LSR#0x15
                    ADDS        R2,R0,LSL#0x0B
                    ADCS        R0,R3,R4
					EORS        R3,R3
					ADC         R4,R3,#0x08
					ADCS        R3,R3
					ADD         R1,R3,LSL#0x17
					UBFX        R3,R1,#0x14,#0x0B
					SUB         R3,#0x0380
					LSR         R1,#0x1F
					ORR         R3,R1,LSL#0x08
					RSB         R1,R4,#0x20
                    LSLS        R1,R0,R1
					LSRS        R0,R4
					LSRS        R2,R4
					ORRS        R2,R1
				    BFI         R0,R3,#0x17,#0x09
					ADD         R0,R2,LSR#0x1F
					POP         {R4-R5,R15}
					ENDP
DoubleMulToFloat    PROC
	                EXPORT      DoubleMulToFloat
	                PUSH        {R4-R6,R14}
	                UBFX        R4,R1,#0x14,#0x0B
					UBFX        R5,R3,#0x14,#0x0B
					EOR         R6,R1,R3
					CBZ         R4,DMTFZeroOperand
					CBZ         R5,DMTFZeroOperand
					ADD         R4,R5
					SUB         R4,#0x077E
					BFI         R6,R4,#0x17,#0x08
					BFC         R1,#0x15,#0x0B
					BFC         R3,#0x15,#0x0B
					ORR         R1,#0x00100000
					ORR         R3,#0x00100000
					UMULL       R4,R5,R0,R3
					UMULL       R0,R14,R0,R2
					ADDS        R4,R14
					ADC         R5,#0x00
					UMULL       R0,R14,R1,R2
					UMULL       R2,R3,R1,R3
					ADDS        R1,R4,R0
					ADCS        R0,R5,R14
					ADC         R3,#0x00
					ADDS        R2,R0
					ADC         R3,#0x00
					LSR         R1,R3,#0x09
					ADD         R0,R6,R1,LSL#0x17
					RSB         R4,R1,#0x0F
					LSLS        R3,R4
					BFI         R0,R3,#0x00,#0x17
					ADDS        R1,#0x09
					LSRS        R2,R1
					ADCS        R0,R2
					POP         {R4-R6,R15}
DMTFZeroOperand     EORS        R0,R0
                    POP         {R4-R6,R15}
	                ENDP
DoubleDivToFloat    PROC
	                EXPORT      DoubleDivToFloat
	                PUSH        {R4-R7,R14}
					UBFX        R4,R1,#0x14,#0x0B
					UBFX        R5,R3,#0x14,#0x0B
					SUBS        R4,R5
					ADDS        R4,#0x7F
					EOR         R14,R1,R3
					BFI         R14,R4,#0x17,#0x08
					UBFX        R4,R3,#0x00,#0x14
					UBFX        R3,R1,#0x00,#0x14
					ORR         R3,#0x100000
					ORR         R4,#0x100000
					MOVS        R1,R0
					EORS        R5,R5
					CMP         R1,R2
					SBCS        R6,R3,R4
					ITTE        LO
					SUBLO       R14,#0x100000
					MOVLO       R6,#0x1A
					MOVHS       R6,#0x19
DDTFDivLoop         LSL         R0,#0x01
                    CMP         R1,R2
					SBCS        R7,R3,R4
                    BLO         DDTFSubSkip
					SUBS        R1,R2
                    SBCS        R3,R4
					ADDS        R0,#0x01
DDTFSubSkip         LSLS        R1,#0x01
					ADC         R3,R5,R3,LSL#0x01
					SUBS        R6,#0x01
                    BNE         DDTFDivLoop
					LSRS        R0,#0x01
					BFI         R0,R14,#0x14,#0x09
                    ADCS        R0,R5
					POP         {R4-R7,R15}
	                ENDP
;///////////////////////////////////////////////////////////////////////////////////
;Four arithmetic operations of double floating point with double floating point results.
DoubleAddToDouble   PROC
					EXPORT      DoubleAddToDouble
					PUSH        {R4,R14}
					BIC         R4,R1,#0x80000000
					BIC         R14,R3,#0x80000000
					CMP         R0,R2
					SBCS        R4,R14
                    ITTT        LO					
					EORLO       R0,R2
                    EORLO       R2,R0
                    EORLO       R0,R2
					ITTT        LO					
					EORLO       R1,R3
                    EORLO       R3,R1
                    EORLO       R1,R3
					UBFX        R14,R1,#0x14,#0x0B
					UBFX        R4,R3,#0x14,#0x0B
					CBZ         R4,DATDZeroOperand
					SUB         R4,R14,R4
					EORS        R14,R1,R3
					BPL         DATDPPOrNN
DATDPAndN           BFC         R3,#0x15,#0x0B
					ORR         R3,#0x100000
                    SUBS        R14,R4,#0x20
                    BLO         DATDShift0LT32Bits
DATDShift0HT32Bits	ANDS        R4,#0x00
                    LSRS        R2,R3,R14
					MOVS        R3,R4
					B           FATDShift0End
DATDZeroOperand     POP         {R4,R15}
DATDShift0LT32Bits  RSB         R14,R4,#0x20
                    LSRS        R2,R4
					LSR         R4,R3,R4
					LSL         R3,R14
DATDShift0End	    ADCS        R2,R3
                    UBFX        R3,R1,#0x00,#0x14
					ORR         R3,#0x100000
                    SUBS        R0,R2
					SBCS        R3,R4
					ITTEE       EQ
					CLZEQ       R2,R0
					ADDEQ       R2,#0x15
					CLZNE       R2,R3
					SUBNE       R2,#0x0B
					SUB         R1,R2,LSL#0x14
					RSBS        R4,R2,#0x20
                    BLO         DATDShift1HT32Bits
DATDShift1LT32Bits  LSRS        R4,R0,R4
					LSLS        R3,R2
					ORRS        R3,R4
					LSLS        R0,R2
            	    BFI         R1,R3,#0x00,#0x14
					POP         {R4,R15}
DATDShift1HT32Bits	SUB         R4,R2,#0x20
                    LSL         R3,R0,R4
					EORS        R0,R0
					CBZ         R3,DATDZeroResult
					BFI         R1,R3,#0x00,#0x14
					POP         {R4,R15}
DATDZeroResult		EORS        R1,R1
                    POP         {R4,R15}
DATDPPOrNN          ORR         R3,#0x100000
                    LSL         R3,#0x0B
					ORR         R3,R2,LSR#0x15
					LSL         R2,#0x0B
                    SUBS        R14,R4,#0x20
                    BLO         DATDShift2LT32Bits
DATDShift2HT32Bits	LSR         R2,R3,R14
					EORS        R3,R3
					B           DATDShift2End
DATDShift2LT32Bits  RSB         R14,R4,#0x20
                    LSRS        R2,R4
					LSL         R14,R3,R14
					LSRS        R3,R4
					ORR         R2,R14
DATDShift2End	    ORR         R4,R1,#0x100000
                    LSL         R4,#0x0B
					ORR         R4,R0,LSR#0x15
                    ADDS        R0,R2,R0,LSL#0x0B
                    ADCS        R3,R4
					EORS        R2,R2
					ADC         R4,R2,#0x0B
					ADCS        R2,R2
					ADD         R1,R2,LSL#0x14
					RSB         R2,R4,#0x20
                    LSLS        R2,R3,R2
					LSRS        R3,R4
					LSRS        R0,R4
                    ADCS        R0,R2
				    BFI         R1,R3,#0x14,#0x0C
					ADC         R1,#0x00
					POP         {R4-R5,R15}
					ENDP
DoubleMulToDouble   PROC
	                EXPORT      DoubleMulToDouble
	                PUSH        {R4-R6,R14}
	                UBFX        R4,R1,#0x14,#0x0B
					UBFX        R5,R3,#0x14,#0x0B
					EOR         R6,R1,R3
					CBZ         R4,DMTDZeroOperand
					CBZ         R5,DMTDZeroOperand
					ADDS        R4,R5
					SUB         R4,#0x03FF
					BFI         R6,R4,#0x14,#0x0B
					BFC         R1,#0x15,#0x0B
					BFC         R3,#0x15,#0x0B
					ORR         R1,#0x00100000
					ORR         R3,#0x00100000
					UMULL       R4,R5,R0,R3
					UMULL       R0,R14,R0,R2
					ADDS        R4,R14
					ADC         R5,#0x00
					UMULL       R0,R14,R1,R2
					UMULL       R2,R3,R1,R3
					ADDS        R1,R4,R0
					ADCS        R0,R5,R14
					ADC         R3,#0x00
					ADDS        R2,R0
					ADC         R3,#0x00
					LSR         R4,R3,#0x09
					ADD         R5,R4,#0x14
					LSRS        R0,R1,R5
					ADD         R1,R6,R4,LSL#0x14
					RSB         R6,R4,#0x0C
					LSL         R3,R6
					BFI         R1,R3,#0x00,#0x14
					LSR         R5,R2,R5
					ORR         R1,R5
					LSL         R2,R6
					ADCS        R0,R2
					ADC         R1,#0x00
					POP         {R4-R6,R15}
DMTDZeroOperand     EORS        R0,R0
                    EORS        R1,R1
                    POP         {R4-R6,R15}
	                ENDP
DoubleDivToDouble   PROC
	                EXPORT      DoubleDivToDouble
	                PUSH        {R4-R8,R14}
					UBFX        R4,R1,#0x14,#0x0B
					UBFX        R5,R3,#0x14,#0x0B
					SUBS        R4,R5
					ADD         R4,#0x03FF
					EOR         R14,R1,R3
					BFI         R14,R4,#0x14,#0x0B
					BFC         R14,#0x00,#0x14
					UBFX        R3,R3,#0x00,#0x14
					UBFX        R5,R1,#0x00,#0x14
					ORR         R3,#0x100000
					ORR         R5,#0x100000
					MOVS        R4,R0
					EORS        R6,R6
					CMP         R4,R2
					SBCS        R0,R5,R3
					ITTE        LO
					SUBLO       R14,#0x100000
					MOVLO       R7,#0x37
					MOVHS       R7,#0x36
DDTDDivLoop         LSLS        R0,#0x01
					ADC         R1,R6,R1,LSL#0x01
                    CMP         R4,R2
					SBCS        R8,R5,R3
                    BLO         DDTDSubSkip
					SUBS        R4,R2
                    SBCS        R5,R3
					ADDS        R0,#0x01
DDTDSubSkip         LSLS        R4,#0x01
					ADC         R5,R6,R5,LSL#0x01
					SUBS        R7,#0x01
                    BNE         DDTDDivLoop
					LSRS        R0,#0x01
					BFI         R0,R1,#0x1F,#0x01
					ADCS        R0,R6
                    BIC         R1,#0x200000
					ADC         R1,R14,R1,LSR#0x01
					POP         {R4-R8,R15}
	                ENDP
					END
