;SFRs definition:
;////////////////////////////////////////////////////////////
GPIOA             EQU        0x40010800
GPIOB             EQU        0x40010C00
GPIOC             EQU        0x40011000
GPIOD             EQU        0x40011400
GPIOE             EQU        0x40011800
GPIOF             EQU        0x40011C00
GPIOG             EQU        0x40012000
;GPIOx registers base address
GPIOxCRL          EQU        0x00
GPIOxCRH          EQU        0x04
GPIOxIDR          EQU        0x08
GPIOxODR          EQU        0x0C
GPIOxBSRR         EQU        0x10
GPIOxBRR          EQU        0x14
GPIOxLCKR         EQU        0x18
;GPIOx registers offset address
RCC               EQU        0x40021000
;RCC registers base address
RCCCR             EQU        0x00
RCCCFGR           EQU        0x04
RCCCIR            EQU        0x08
RCCAPB2RSTR       EQU        0x0C
RCCAPB1RSTR       EQU        0x10
RCCAHBENR         EQU        0x14
RCCAPB2ENR        EQU        0x18
RCCAPB1ENR        EQU        0x1C
RCCBDCR           EQU        0x20
RCCCSR            EQU        0x24
;RCC registers offset address
AFIO              EQU        0x40010000
;AFIO registers base address
AFIOEVCR          EQU        0x00
AFIOMAPR          EQU        0x04
AFIOEXTICR1       EQU        0x08
AFIOEXTICR2       EQU        0x0C
AFIOEXTICR3       EQU        0x10
AFIOEXTICR4       EQU        0x14
AFIOMAPR2         EQU        0x1C
;AFIO registers offset address
FLASH             EQU        0x40022000
;FLASH registers base address
FLASHACR          EQU        0x00
FLASHKEYR         EQU        0x04
FLASHOPTKEYR      EQU        0x08
FLASHSR           EQU        0x0C
FLASHCR           EQU        0x10
FLASHAR           EQU        0x14
FLASHOBR          EQU        0x1C        
FLASHWRPR         EQU        0x20
FLASHKEYR2        EQU        0x44
FLASHSR2          EQU        0x4C
FLASHCR2          EQU        0x50
FLASHAR2          EQU        0x54
;FLASH registers offset address
FMSC              EQU        0xA0000000
;FMSC registers base address
FSMCBCR1          EQU        0x0000 
FSMCBCR2          EQU        0x0008
FSMCBCR3          EQU        0x0010
FSMCBCR4          EQU        0x0018
FSMCBTR1          EQU        0x0004
FSMCBTR2          EQU        0x000C
FSMCBTR3          EQU        0x0014
FSMCBTR4          EQU        0x001C
FSMCBWTR1         EQU        0x0104
FSMCBWTR2         EQU        0x010C
FSMCBWTR3         EQU        0x0114
FSMCBWTR4         EQU        0x011C
FSMCPCR2          EQU        0xA0000060
FSMCPCR3          EQU        0xA0000080
FSMCPCR4          EQU        0xA00000A0
FSMCSR2           EQU        0xA0000064
FSMCSR3           EQU        0xA0000084
FSMCSR4           EQU        0xA00000A4
FSMCPMEM2         EQU        0xA0000068
FSMCPMEM3         EQU        0xA0000088
FSMCPMEM4         EQU        0xA00000A8
FSMCPATT2         EQU        0xA000006C
FSMCPATT3         EQU        0xA000008C
FSMCPATT4         EQU        0xA00000AC
FSMCPIO4          EQU        0xA00000B0
FSMCECCR2         EQU        0xA0000074
FSMCECCR3         EQU        0xA0000094
;FMSC registers offset address
OTGFS             EQU        0x50000000
;USB OTG FS registers base address
OTGFSGOTGCTL      EQU        0x000
OTGFSGOTGINT      EQU        0x004
OTGFSGAHBCFG      EQU        0x008
OTGFSGUSBCFG      EQU        0x00C
OTGFSGRSTCTL      EQU        0x010
OTGFSGINTSTS      EQU        0x014
OTGFSGINTMSK      EQU        0x018
OTGFSGRXSTSR      EQU        0x01C 
;0x01C: OTG_FS_GRXSTSR (host mode), OTG_FS_GRXSTSR (Device mode).
;0x020: OTG_FS_GRXSTSR (host mode), OTG_FS_GRXSTSPR (Device mode).
OTGFSGRXSTSPR     EQU        0x020
OTGFSGRXFSIZ      EQU        0x024
OTGFSHNPTXFSIZ    EQU        0x028  ;OTG_FS_DIEPTXF0
OTGFSHNPTXSTS     EQU        0x02C
OTGFSGCCFG        EQU        0x038
OTGFSCID          EQU        0x03C
OTGFSHPTXFSIZ     EQU        0x100
OTGFSDIEPTXF1     EQU        0x104
OTGFSDIEPTXF2     EQU        0x108
OTGFSDIEPTXF3     EQU        0x10C
OTGFSHCFG         EQU        0x400
OTGFSHFIR         EQU        0x404
OTGFSHFNUM        EQU        0x408
OTGFSHPTXSTS      EQU        0x410
OTGFSHAINT        EQU        0x414
OTGFSHAINTMSK     EQU        0x418
OTGFSHPRT         EQU        0x440
OTGFSHCCHAR0      EQU        0x500
OTGFSHCCHAR1      EQU        0x520
OTGFSHCCHAR2      EQU        0x540
OTGFSHCCHAR3      EQU        0x560
OTGFSHCCHAR4      EQU        0x580
OTGFSHCCHAR5      EQU        0x5A0
OTGFSHCCHAR6      EQU        0x5C0
OTGFSHCCHAR7      EQU        0x5E0
OTGFSHCINT0       EQU        0x508
OTGFSHCINT1       EQU        0x528
OTGFSHCINT2       EQU        0x548
OTGFSHCINT3       EQU        0x568
OTGFSHCINT4       EQU        0x588
OTGFSHCINT5       EQU        0x5A8
OTGFSHCINT6       EQU        0x5C8
OTGFSHCINT7       EQU        0x5E8
OTGFSHCINTMSK0    EQU        0x50C
OTGFSHCINTMSK1    EQU        0x52C
OTGFSHCINTMSK2    EQU        0x54C
OTGFSHCINTMSK3    EQU        0x56C
OTGFSHCINTMSK4    EQU        0x58C
OTGFSHCINTMSK5    EQU        0x5AC
OTGFSHCINTMSK6    EQU        0x5CC
OTGFSHCINTMSK7    EQU        0x5EC
OTGFSHCTSIZ0      EQU        0x510
OTGFSHCTSIZ1      EQU        0x530
OTGFSHCTSIZ2      EQU        0x550
OTGFSHCTSIZ3      EQU        0x570
OTGFSHCTSIZ4      EQU        0x590
OTGFSHCTSIZ5      EQU        0x5B0
OTGFSHCTSIZ6      EQU        0x5D0
OTGFSHCTSIZ7      EQU        0x5F0
OTGFSDCFG         EQU        0x800
OTGFSDCTL         EQU        0x804
OTGFSDSTS         EQU        0x808
OTGFSDIEPMSK      EQU        0x810
OTGFSDOEPMSK      EQU        0x814
OTGFSDAINT        EQU        0x818
OTGFSDAINTMSK     EQU        0x81C
OTGFSDVBUSDIS     EQU        0x828
OTGFSDVBUSPULSE   EQU        0x82C
OTGFSDIEPEMPMSK   EQU        0x834
OTGFSDIEPCTL0     EQU        0x900
OTGFSDTXFSTS0     EQU        0x918
OTGFSDIEPCTL1     EQU        0x920
OTGFSDTXFSTS1     EQU        0x938
OTGFSDIEPCTL2     EQU        0x940
OTGFSDTXFSTS2     EQU        0x958
OTGFSDIEPCTL3     EQU        0x960
OTGFSDTXFSTS3     EQU        0x978
OTGFSDOEPCTL0     EQU        0xB00
OTGFSDOEPCTL1     EQU        0xB20
OTGFSDOEPCTL2     EQU        0xB40
OTGFSDOEPCTL3     EQU        0xB60
OTGFSDIEPINT0     EQU        0x908
OTGFSDIEPINT1     EQU        0x928
OTGFSDIEPINT2     EQU        0x948
OTGFSDIEPINT3     EQU        0x968
OTGFSDOEPINT0     EQU        0xB08
OTGFSDOEPINT1     EQU        0xB28
OTGFSDOEPINT2     EQU        0xB48
OTGFSDOEPINT3     EQU        0xB68
OTGFSDIEPTSIZ0    EQU        0x910
OTGFSDIEPTSIZ1    EQU        0x930
OTGFSDIEPTSIZ2    EQU        0x950
OTGFSDIEPTSIZ3    EQU        0x970
OTGFSDOEPTSIZ0    EQU        0xB10
OTGFSDOEPTSIZ1    EQU        0xB30
OTGFSDOEPTSIZ2    EQU        0xB50
OTGFSDOEPTSIZ3    EQU        0xB70
OTGFSPCGCCTL      EQU        0xE00
;USB OTG FS registers offset address
Ethernet          EQU        0x40028000
;Ethernet registers base address
ETHMACCR          EQU        0x00
ETHMACFFR         EQU        0x04
ETHMACHTHR        EQU        0x08
ETHMACHTLR        EQU        0x0C
ETHMACMIIAR       EQU        0x10
ETHMACMIIDR       EQU        0x14
ETHMACFCR         EQU        0x18
ETHMACVLANTR      EQU        0x1C
ETHMACRWUFFR      EQU        0x28
ETHMACPMTCSR      EQU        0x2C
ETHMACSR          EQU        0x38
ETHMACIMR         EQU        0x3C
ETHMACA0HR        EQU        0x40
ETHMACA0LR        EQU        0x44
ETHMACA1HR        EQU        0x48
ETHMACA1LR        EQU        0x4C
ETHMACA2HR        EQU        0x50
ETHMACA2LR        EQU        0x54
ETHMACA3HR        EQU        0x58
ETHMACA3LR        EQU        0x5C
ETHMMCCR          EQU        0x100
ETHMMCRIR         EQU        0x104
ETHMMCTIR         EQU        0x108
ETHMMCRIMR        EQU        0x10C
ETHMMCTIMR        EQU        0x110
ETHMMCTGFSCCR     EQU        0x14C
ETHMMCTGFMSCCR    EQU        0x150
ETHMMCTGFCR       EQU        0x168
ETHMMCRFCECR      EQU        0x194
ETHMMCRFAECR      EQU        0x198
ETHMMCRGUFCR      EQU        0x1C4
ETHPTPTSCR        EQU        0x700
ETHPTPSSIR        EQU        0x704
ETHPTPTSHR        EQU        0x708
ETHPTPTSLR        EQU        0x70C
ETHPTPTSHUR       EQU        0x710
ETHPTPTSLUR       EQU        0x714
;Ethernet registers offset address
CRC               EQU        0x40023000
;CRC registers base address
CRCDR             EQU        0x00
CRCIDR            EQU        0x04
CRCCR             EQU        0x08
;CRC registers offset address
DMA1              EQU        0x40020000
DMA2              EQU        0x40020400
;DMAx registers base address
DMAxISR           EQU        0x000
DMAxIFCR          EQU        0x004
DMAxCCR1          EQU        0x008
DMAxCNDTR1        EQU        0x00C
DMAxCPAR1         EQU        0x010
DMAxCMAR1         EQU        0x014
DMAxCCR2          EQU        0x01C
DMAxCNDTR2        EQU        0x020
DMAxCPAR2         EQU        0x024 
DMAxCMAR2         EQU        0x028
DMAxCCR3          EQU        0x030
DMAxCNDTR3        EQU        0x034
DMAxCPAR3         EQU        0x038
DMAxCMAR3         EQU        0x03C
DMAxCCR4          EQU        0x044		
DMAxCNDTR4        EQU        0x048		
DMAxCPAR4         EQU        0x04C		
DMAxCMAR4         EQU        0x050		
DMAxCCR5          EQU        0x058		
DMAxCNDTR5        EQU        0x05C		
DMAxCPAR5         EQU        0x060		
DMAxCMAR5         EQU        0x064		
DMAxCCR6          EQU        0x06C		
DMAxCNDTR6        EQU        0x070		
DMAxCPAR6         EQU        0x074		
DMAxCMAR6         EQU        0x078		
DMAxCCR7          EQU        0x080		
DMAxCNDTR7        EQU        0x084
DMAxCPAR7         EQU        0x088
DMAxCMAR7         EQU        0x08C			  
;DMAx registers offset address
SDIO              EQU        0x40018000
;SDIO registers base address
SDIOPOWER         EQU        0x00
SDIOCLKCR	      EQU        0x04
SDIOARG           EQU        0x08
SDIOCMD           EQU        0x0C
SDIORESPCMD       EQU        0x10
SDIORESP1         EQU        0x14
SDIORESP2         EQU        0x18
SDIORESP3         EQU        0x1C
SDIORESP4         EQU        0x20
SDIODTIMER        EQU        0x24
SDIODLEN          EQU        0x28
SDIODCTRL         EQU        0x2C
SDIODCOUNT        EQU        0x30
SDIOSTA           EQU        0x34
SDIOICR           EQU        0x38
SDIOMASK          EQU        0x3C
SDIOFIFOCNT       EQU        0x48
SDIOFIFO          EQU        0x80
;SDIO registers offset address
SPI1              EQU        0x40013000
SPI2              EQU        0x40003800
SPI3              EQU        0x40003C00
;SPIx registers base address
SPIxCR1           EQU        0x00
SPIxCR2           EQU        0x04
SPIxSR            EQU        0x08
SPIxDR            EQU        0x0C
SPIxCRCPR         EQU        0x10
SPIxRXCRCR        EQU        0x14
SPIxTXCRCR        EQU        0x18
SPIxI2SCFGR       EQU        0x1C
SPIxI2SPR         EQU        0x20
;SPIx registers offset address
TIM1              EQU        0x40012C00
TIM2              EQU        0x40000000
TIM3              EQU        0x40000400
TIM4              EQU        0x40000800
TIM5              EQU        0x40000C00
TIM6              EQU        0x40001000
TIM7              EQU        0x40001400
TIM8              EQU        0x40013400
TIM9              EQU        0x40014C00
TIM10             EQU        0x40015000
TIM11             EQU        0x40015400
TIM12             EQU        0x40001800
TIM13             EQU        0x40001C00
TIM14             EQU        0x40002000
;TIMx timer registers base address
TIMxCR1           EQU        0x00
TIMxCR2           EQU        0x04
TIMxSMCR          EQU        0x08
TIMxDIER          EQU        0x0C
TIMxSR            EQU        0x10
TIMxEGR           EQU        0x14
TIMxCCMR1         EQU        0x18
TIMxCCMR2         EQU        0x1C
TIMxCCER          EQU        0x20
TIMxCNT           EQU        0x24
TIMxPSC           EQU        0x28
TIMxARR           EQU        0x2C
TIMxRCR           EQU        0x30
TIMxCCR1          EQU        0x34
TIMxCCR2          EQU        0x38
TIMxCCR3          EQU        0x3C
TIMxCCR4          EQU        0x40
TIMxBDTR          EQU        0x44
TIMxDCR           EQU        0x48
TIMxDMAR          EQU        0x4C
;TIMx timer registers offset address
PWR               EQU        0x40007000
;Power control registers base address
PWRCR             EQU        0x000
PWRCSR            EQU        0x004
;Power control registers offset address
BKP               EQU        0x40006C00
;Backup registers base address
BKPDR1            EQU        0x04
BKPDR2            EQU        0x08
BKPDR3            EQU        0x0C
BKPDR4            EQU        0x10
BKPDR5            EQU        0x14
BKPDR6            EQU        0x18
BKPDR7            EQU        0x1C
BKPDR8            EQU        0x20
BKPDR9            EQU        0x24
BKPDR10           EQU        0x28
BKPRTCCR          EQU        0x2C
BKPCR             EQU        0x30
BKPCSR            EQU        0x34
BKPDR11           EQU        0x40
BKPDR12           EQU        0x44
BKPDR13           EQU        0x48
BKPDR14           EQU        0x4C
BKPDR15           EQU        0x50
BKPDR16           EQU        0x54
BKPDR17           EQU        0x58
BKPDR18           EQU        0x5C
BKPDR19           EQU        0x60
BKPDR20           EQU        0x64
BKPDR21           EQU        0x68
BKPDR22           EQU        0x6C
BKPDR23           EQU        0x70
BKPDR24           EQU        0x74
BKPDR25           EQU        0x78
BKPDR26           EQU        0x7C
BKPDR27           EQU        0x80
BKPDR28           EQU        0x84
BKPDR29           EQU        0x88
BKPDR30           EQU        0x8C
BKPDR31           EQU        0x90
BKPDR32           EQU        0x94
BKPDR33           EQU        0x98
BKPDR34           EQU        0x9C
BKPDR35           EQU        0xA0
BKPDR36           EQU        0xA4
BKPDR37           EQU        0xA8
BKPDR38           EQU        0xAC
BKPDR39           EQU        0xB0
BKPDR40           EQU        0xB4
BKPDR41           EQU        0xB8
BKPDR42           EQU        0xBC
;Backup registers offset address
bxCAN1            EQU        0x40006400
bxCAN2            EQU        0x40006800
;bxCANx registers base address
CANxMCR           EQU        0x000
CANxMSR		      EQU        0x004
CANxTSR           EQU        0x008
CANxRF0R          EQU        0x00C
CANxRF1R          EQU        0x010
CANxIER	      	  EQU        0x014
CANxESR           EQU        0x018
CANxBTR           EQU        0x01C
CANxTI0R          EQU        0x180
CANxTDT0R	   	  EQU        0x184
CANxTDL0R         EQU        0x188
CANxTDH0R         EQU        0x18C
CANxTI1R          EQU        0x190
CANxTDT1R	      EQU        0x194
CANxTDL1R         EQU        0x198
CANxTDH1R         EQU        0x19C
CANxTI2R          EQU        0x1A0
CANxTDT2R	      EQU        0x1A4
CANxTDL2R         EQU        0x1A8
CANxTDH2R         EQU        0x1AC
CANxRI0R          EQU        0x1B0
CANxRDT0R	      EQU        0x1B4
CANxRDL0R         EQU        0x1B8
CANxRDH0R         EQU        0x1BC
CANxRI1R          EQU        0x1C0
CANxRDT1R   	  EQU        0x1C4
CANxRDL1R         EQU        0x1C8
CANxRDH1R         EQU        0x1CC
CANxFMR           EQU        0x200
CANxFM1R	      EQU        0x204
CANxFS1R          EQU        0x20C
CANxFFA1R         EQU        0x214
CANxFA1R          EQU        0x21C
CANxF0R1          EQU        0x240
CANxF0R2          EQU        0x244
CANxF1R1          EQU        0x248
CANxF1R2          EQU        0x24C
CANxF2R1          EQU        0x250
CANxF2R2          EQU        0x254
CANxF3R1          EQU        0x258
CANxF3R2          EQU        0x25C
CANxF4R1          EQU        0x260
CANxF4R2          EQU        0x264
CANxF5R1          EQU        0x268
CANxF5R2          EQU        0x26C
CANxF6R1          EQU        0x270
CANxF6R2          EQU        0x274
CANxF7R1          EQU        0x278
CANxF7R2          EQU        0x27C
CANxF8R1          EQU        0x280
CANxF8R2          EQU        0x284
CANxF9R1          EQU        0x288
CANxF9R2          EQU        0x28C
CANxF10R1         EQU        0x290
CANxF10R2         EQU        0x294
CANxF11R1         EQU        0x298
CANxF11R2         EQU        0x29C
CANxF12R1         EQU        0x2A0
CANxF12R2         EQU        0x2A4
CANxF13R1         EQU        0x2A8
CANxF13R2         EQU        0x2AC		
;bxCANx registers offset address
USB               EQU        0x40005C00
;USB device FS registers base address
USBEP0R           EQU        0x00
USBEP1R           EQU        0x04
USBEP2R           EQU        0x08
USBEP3R           EQU        0x0C
USBEP4R           EQU        0x10
USBEP5R           EQU        0x14
USBEP6R           EQU        0x18
USBEP7R           EQU        0x1C
USBCNTR           EQU        0x40
USBISTR           EQU        0x44
USBFNR            EQU        0x48
USBDADDR          EQU        0x4C
USBBTABLE         EQU        0x50
;USB device FS offset address
I2C1              EQU        0x40005400
I2C2              EQU        0x40005800
;IICx registers base address
I2CxCR1           EQU        0x00
I2CxCR2	          EQU        0x04
I2CxOAR1	      EQU        0x08
I2CxOAR2          EQU        0x0C
I2CxDR      	  EQU        0x10
I2CxSR1     	  EQU        0x14
I2CxSR2           EQU        0x18
I2CxCCR     	  EQU        0x1C
I2CxTRISE	      EQU        0x20
;IICx registers offset address
USART1            EQU        0x40013800
USART2            EQU        0x40004400
USART3            EQU        0x40004800
USART4            EQU        0x40004C00
USART5            EQU        0x40005000
;USARTx registers base address
USARTxSR          EQU        0x00
USARTxDR          EQU        0x04
USARTxBRR         EQU        0x08
USARTxCR1         EQU        0x0C
USARTxCR2         EQU        0x10
USARTxCR3         EQU        0x14
USARTxGTPR        EQU        0x18
;USARTx registers offset address
IWDG              EQU        0x40003000
;Independent watchdog registers base address
IWDGKR            EQU        0x00
IWDGPR            EQU        0x04
IWDGRLR           EQU        0x08
IWDGSR            EQU        0x0C
;Independent watchdog registers offset address
WWDG              EQU        0x40002C00
;Window watchdog registers base address
WWDGCR            EQU        0x00
WWDGCFR           EQU        0x04
WWDGSR            EQU        0x08
;Window watchdog registers offset address
RTC               EQU        0x40002800
;RTC registers base address
RTCCRH            EQU        0x00
RTCCRL            EQU        0x04
RTCPRLH           EQU        0x08
RTCPRLL           EQU        0x0C
RTCDIVH           EQU        0x10
RTCDIVL           EQU        0x14
RTCCNTH           EQU        0x18
RTCCNTL           EQU        0x1C
RTCALRH           EQU        0x20
RTCALRL           EQU        0x24
;RTC registers offset address
ADC1              EQU        0x40012400
ADC2              EQU        0x40012800
ADC3              EQU        0x40013C00
;ADCx registers base address
ADCxSR            EQU        0x00
ADCxCR1           EQU        0x04
ADCxCR2           EQU        0x08
ADCxSMPR1         EQU        0x0C
ADCxSMPR2         EQU        0x10
ADCxJOFR1         EQU        0x14
ADCxJOFR2         EQU        0x18
ADCxJOFR3         EQU        0x1C
ADCxJOFR4         EQU        0x20
ADCxHTR           EQU        0x24
ADCxLTR           EQU        0x28
ADCxSQR1          EQU        0x2C
ADCxSQR2          EQU        0x30
ADCxSQR3          EQU        0x34
ADCxJSQR          EQU        0x38
ADCxJDR1          EQU        0x3C
ADCxJDR2          EQU        0x40
ADCxJDR3          EQU        0x44
ADCxJDR4          EQU        0x48
ADCxDR            EQU        0x4C
;ADCx registers offset address
DAC               EQU        0x40007400
;DAC registers base address
DACCR             EQU        0x00
DACSWTRIGR        EQU        0x04
DACDHR12R1        EQU        0x08
DACDHR12L1        EQU        0x0C
DACDHR8R1         EQU        0x10
DACDHR12R2        EQU        0x14
DACDHR12L2        EQU        0x18
DACDHR8R2         EQU        0x1C
DACDHR12RD        EQU        0x20
DACDHR12LD        EQU        0x24
DACDHR8RD         EQU        0x28
DACDOR1           EQU        0x2C
DACDOR2           EQU        0x30
;DAC registers offset address
EXTI              EQU        0x40010400
;EXTI registers base address
EXTIIMR           EQU        0x00
EXTIEMR           EQU        0x04
EXTIRTSR          EQU        0x08
EXTIFTSR          EQU        0x0C
EXTISWIER         EQU        0x10
EXTIPR            EQU        0x14
;EXTI registers offset address
SCB               EQU        0xE000ED00
;SCB registers base address
SCBCPUID          EQU        0x00
SCBICSR           EQU        0x40
SCBVTOR           EQU        0x08
SCBAIRCR          EQU        0x0C
SCBSCR            EQU        0x10
SCBCCR            EQU        0x14
SCBSHPR1          EQU        0x18
SCBSHPR2          EQU	     0x1C
SCBSHPR3          EQU	     0x20
SCBSHCSR          EQU        0x24
SCBCFSR           EQU        0x28
SCBHFSR           EQU        0x2C
SCBMMAR           EQU        0x34
SCBBFAR           EQU        0x38
;SCB registers offset address
STK               EQU        0xE000E010
;SysTick registers base address
STKCTRL           EQU        0x00
STKLOAD           EQU        0x04
STKVAL            EQU        0x08
STKCALIB          EQU        0x0C
;SysTick registers offset address
NVIC              EQU        0xE000E100
;NVIC Registers base address
NVICISER0         EQU        0x000
NVICISER1         EQU        0x004
NVICISER2         EQU        0x008
NVICICER0         EQU        0x080
NVICICER1         EQU        0x084
NVICICER2         EQU        0x088
NVICISPR0         EQU        0x100
NVICISPR1         EQU        0x104
NVICISPR2         EQU        0x108
NVICICPR0         EQU        0x180
NVICICPR1         EQU        0x184
NVICICPR2         EQU        0x188
NVICIABR0         EQU        0x200
NVICIABR1         EQU        0x204
NVICIABR2         EQU        0x208
NVICIPR0          EQU        0x300
NVICIPR1          EQU        0x304
NVICIPR2          EQU        0x308
NVICIPR3          EQU        0x30C
NVICIPR4          EQU        0x310
NVICIPR5          EQU        0x314
NVICIPR6          EQU        0x318
NVICIPR7          EQU        0x31C
NVICIPR8          EQU        0x320
NVICIPR9          EQU        0x324
NVICIPR10         EQU        0x328
NVICIPR11         EQU        0x32C
NVICIPR12         EQU        0x330
NVICIPR13         EQU        0x334
NVICIPR14         EQU        0x338
NVICIPR15         EQU        0x33C
NVICIPR16         EQU        0x340
NVICIPR17         EQU        0x344
NVICIPR18         EQU        0x348
NVICIPR19         EQU        0x34C
NVICIPR20         EQU        0x350
NVICSTIR          EQU        0xE00
;NVIC Registers offset address
MPU               EQU        0xE000ED90
;MPU Registers base address
MPUTYPER          EQU        0x00
MPUCR             EQU        0x04
MPURNR            EQU        0x08
MPURBAR           EQU        0x0C
MPURASR           EQU        0x10
MPURBARA1         EQU        0x14
MPURASRA1         EQU        0x18
MPURBARA2         EQU        0x1C
MPURASRA2         EQU        0x20
MPURBARA3         EQU        0x1C
MPURASRA3         EQU        0x20
;MPU Registers offset address
USBSRAM           EQU        0x40006000
CANSRAM           EQU        0x40006000
;Shared USB/CAN SRAM 512 bytes
	              END